#ifndef ORT_H
#define ORT_H
#include <cassert>
#include <cctype>
#include <cmath>          // wegen sqrt()
#include <cstdlib>
#include <iostream>
#include <string>

class Ort {
public:
  constexpr Ort(int einX = 0, int einY = 0) : xKoordinate{einX}, yKoordinate{einY} {}

  [[nodiscard]] constexpr auto getX() const { return xKoordinate; }
  [[nodiscard]] constexpr auto getY() const { return yKoordinate; }

  constexpr void aendern(int x, int y)
  {
    xKoordinate = x;
    yKoordinate = y;
  }

private:
  int xKoordinate;
  int yKoordinate;
};

// globale Funktionen

// Berechnung der Entfernung zwischen zwei Orten
[[nodiscard]] constexpr auto entfernung(Ort ort1, Ort ort2)
{
  auto dx = static_cast<double>(ort1.getX() - ort2.getX());
  auto dy = static_cast<double>(ort1.getY() - ort2.getY());
  return std::sqrt(dx * dx + dy * dy);
}

// Anzeige auf der Standardausgabe
inline void anzeigen(Ort O) { std::cout << '(' << O.getX() << ", " << O.getY() << ')'; }

// Gleichheitsoperator
[[nodiscard]] constexpr bool operator==(Ort ort1, Ort ort2)
{
  return (ort1.getX() == ort2.getX() && ort1.getY() == ort2.getY());
}

// Überladen des Ausgabeoperators zur Ausgabe eines Ortes
inline std::ostream& operator<<(std::ostream& os, Ort einOrt)
{
  os << " (" << einOrt.getX() << ", " << einOrt.getY() << ')';
  return os;
}
#endif

