#include <iostream>
#include <vector>

// Der Prototyp des Algorithmus wird durch ein Template ersetzt:
template <class Iterator, typename T>
[[nodiscard]] Iterator find(Iterator begin, Iterator end, const T& wert)
{
  while (begin != end                  // Zeigervergleich
         && *begin != wert) {          // Dereferenzierung und Objektvergleich
    ++begin;                           // nächste Stelle
  }
  return begin;
}

int main()
{
  std::vector<int> einContainer(100);          // Container definieren
  // Container mit beliebigen Werten füllen (hier: gerade Zahlen)
  for (int i = 0; i < einContainer.size(); ++i) {
    einContainer[i] = 2 * i;
  }
  int zahl{0};
  while (zahl != -1) {
    std::cout << " gesuchte Zahl eingeben (-1 = Ende):";
    std::cin >> zahl;
    if (zahl != -1) {                           // weitermachen?
      // globales find() von oben benutzen:
      auto position =                   // auto = vector<int>::const_iterator
          ::find(einContainer.begin(),          // Container-Methoden
                 einContainer.end(), zahl);
      if (position != einContainer.end()) {
        std::cout << "gefunden an Position " 
                  << (position - einContainer.begin()) << '\n';
      }
      else {
        std::cout << zahl << " nicht gefunden!\n";
      }
    }
  }
}

