#include <iostream>

void anzeigen() { std::cout << '\n'; }

template <typename T, typename... Rest>
void anzeigen(const T& obj, const Rest&... rest)
{
  std::cout << obj << ' ';
  anzeigen(rest...);
}

template <typename... Args>
void f1(const Args&... args)
{
  anzeigen(args...);                        // Expansion p1, p2, p3
}
template <typename... Args>
void f2(Args... args)                       // Kopie, weil args geändert wird
{
  anzeigen(++args...);                      // Expansion ++p1, ++p2, ++p3
}

int main()
{
  f1(1, 2, 3);                              // 1 2 3
  f2(1, 2, 3);                              // 2 3 4
}

