#include "RegexTester.h"
#include <iostream>
#include <utility>

RegexTester::RegexTester(const std::string& regEx, std::string teststr)
  : rgx{regEx}, rgxstring{regEx}, teststring{std::move(teststr)}
{}

void RegexTester::run()
{
  std::sregex_iterator erster(teststring.begin(), teststring.end(), rgx);
  std::sregex_iterator letzter;
  std::cout << "Regex: " << rgxstring << "  Teststring: " << teststring << '\n';
  if (erster == letzter) {
    std::cout << "nichts gefunden\n";
  }
  else {
    while (erster != letzter) {
      auto ergebnis = *erster++;            // gut, dass es auto gibt...
      // auto = std::match_results<std::string::const_iterator>
      for (auto i {0z}; i < ssize(ergebnis); ++i) {
        if (i > 0) {
          std::cout << "Capturing Group " << i << ": ";
        }
        std::cout << "\"" << ergebnis.str(i) << "\" gefunden. Position " 
                  << ergebnis.position(i);
        if (ergebnis.length(i) > 1) {
          std::cout << " bis " << ergebnis.position(i) + ergebnis.length(i) - 1;
        }
        std::cout << '\n';
      }
    }
  }
}

