#ifndef PRODUCER_H
#define PRODUCER_H
#include "Ablage.h"
#include <Random.h>
#include <chrono>
#include <iostream>
#include <syncstream>

class Producer {
public:
  Producer(Ablage& a, int i) : ablage(a), id{i} {}

  void operator()()
  {
    for (int i = 0; i < 5 && !ablage.istBeendet(); ++i) {
      int wert{id * 10 + i};
      std::this_thread::sleep_for(std::chrono::milliseconds(200 + zufall()));
      ablage.put(wert);
      std::osyncstream(std::cout)
          << "Producer Nr. " << id << " legt ab: " << wert << std::endl;
    }
    std::osyncstream(std::cout)
        << "Producer " << id << " beendet sich." << std::endl;
  }

private:
  Ablage& ablage;
  int id;
  Random zufall{500};
};
#endif
