#ifndef ANTWORTAUSWERTER_H
#define ANTWORTAUSWERTER_H
#include "ClientAnfrage.h"
#include <array>
#include <fstream>

class AntwortAuswerter {
public:
  AntwortAuswerter(ClientAnfrage& r)
   : clientAnfrage(r), socket(r.getSocket()), dateiname(r.getDateiname()),
   header("noch undefiniert"), status(-1)
  { }

  void receive()
  {
    if (!clientAnfrage.istGesendet()) {
      clientAnfrage.send();
    }
    std::ofstream ausgabe(dateiname, std::ios::binary);  // zur Speicherung
                                                         // des Contents
    auto anzahl{0u};
    std::array<char, 4096> buf {0};
    do {
      boost::system::error_code error;
      anzahl = socket.read_some(boost::asio::buffer(buf), error);
      if (error == boost::asio::error::eof) {
        break;                               // kein Fehler, normales Ende
      }
      else {                                 // Puffer auswerten
        if (status == -1) {
          std::string tmp(buf.begin(), buf.begin()+anzahl);
          auto headerEnde = tmp.find("\r\n\r\n");
          header = tmp.substr(0, headerEnde);
          auto startInhalt = headerEnde + 4;  // CRLF überspringen
          // restliche Bytes wegschreiben
          auto rest = static_cast<std::streamsize>(anzahl - startInhalt); 
          if (rest > 0) {
            ausgabe.write(buf.begin() + startInhalt, rest);
          }
          status = atoi(buf.begin() + header.find(' ') + 1);
        }
        else {
          ausgabe.write(buf.begin(), anzahl);
        }
      }
    } while (anzahl > 0);
    ausgabe.close();
  }
  auto getStatus() const { return status; }
  const std::string& getHeader() const { return header; }
private:
  ClientAnfrage& clientAnfrage;
  boost::asio::ip::tcp::socket& socket;
  const std::string& dateiname;
  std::string header;
  int status;
};
#endif
