#include <boost/asio.hpp>
#include <array>
#include <iostream>
using namespace std;

[[nodiscard]] char formatWahl()
{
  char ein {};
  do {
    cout << "\nFormatwahl : 1 = Standard, 2 = Langform für Tag und Monat,\n"
            "3 = nur die Uhrzeit, 4 = Sekunden seit 1.1.1970, "
            "0 = Programmende: ";
    cin >> ein;
  } while (ein < '0' || ein > '4');
  return ein;
}

int main(int argc, char* argv[])
{
  if (argc != 3) {
    cout << "Gebrauch: " << argv[0] << " <IP-Adresse> <port>" << endl;
    return 1;
  }
  boost::asio::io_service ioService;
  unsigned short port = atoi(argv[2]);
  boost::asio::ip::tcp::endpoint 
          server(boost::asio::ip::address::from_string(argv[1]), port);
  array<char, 2> auftrag {0};
  while ((auftrag[0] = formatWahl()) != '0') {
    boost::asio::ip::tcp::socket socket(ioService);
    socket.connect(server);
    socket.write_some(boost::asio::buffer(auftrag, 2));     // 2 Bytes
    constexpr int max{80};
    array<char, max + 1> buf{};
    // Antwort lesen
    auto anzahlBytes = socket.read_some(boost::asio::buffer(buf, max));
    buf.at(anzahlBytes) = '\0';                 // Rest für Ausgabe ignorieren
    cout << buf.data() << '\n';
  }
}
