// Klasse für rationale Zahlen mit überladenen Operatoren
#ifndef RATIONAL_H
#define RATIONAL_H
#include <iostream>

class [[nodiscard]] Rational {
public:
  Rational(long z = 0L, long n = 1L);       // ersetzt Typumwandlungskonstruktor
  // Abfragen
  [[nodiscard]] long getZaehler() const;
  [[nodiscard]] long getNenner() const;

  // arithmetische Methoden
  Rational& operator+=(Rational);
  Rational& operator-=(Rational);
  Rational& operator*=(Rational);
  Rational& operator/=(Rational);

  // weitere Methoden
  void set(long zaehler, long nenner);
  void kehrwert();
  void kuerzen();

private:
  long zaehler, nenner;
};

// inline Methoden
inline long Rational::getZaehler() const { return zaehler; }
inline long Rational::getNenner() const { return nenner; }

// freie Operatoren
Rational operator+(Rational, Rational);
Rational operator-(Rational, Rational);
Rational operator*(Rational, Rational);
Rational operator/(Rational, Rational);
bool operator==(Rational, Rational);

// freie Funktionen zur Ein- und Ausgabe
std::ostream& operator<<(std::ostream&, Rational);
std::istream& operator>>(std::istream&, Rational&);
#endif
