#include <iostream>

[[nodiscard]] long long fakultaet0(int zahl)    // nicht constexpr
{ 
  long long fak{1uL};
  while (zahl > 1) {
    fak *= zahl--;
  }
  return fak;
}

[[nodiscard]] constexpr long long fakultaet1(int zahl) // constexpr
{
  long long fak{1uL};
  while (zahl > 1) {
    fak *= zahl--;
  }
  return fak;      // rekursiv:  return zahl < 2 ? 1 : zahl * fakultaet1(zahl - 1);
}

[[nodiscard]] int getWert()                     //  nicht-constexpr
{ 
  return 3; 
}

int main()
{
  const long long erg0{fakultaet0(3)};          // const, aber nicht constexpr
  std::cout << "Ergebnis = " << erg0 << '\n';
  
  // 1) constexpr-Funktion liefert nicht-constexpr Wert
  int zahl{4u};                                 // kein const
  long long erg1{fakultaet1(zahl)};
  std::cout << "Ergebnis = " << erg1 << '\n';
  
  // 2) constexpr-Funktion liefert nicht-constexpr Wert
  const int czahl1{getWert()};                  // nicht mit constexpr initialisiert
  long long erg2{fakultaet1(czahl1)};
  std::cout << "Ergebnis = " << erg2 << '\n';
  
  // 3) constexpr-Funktion liefert constexpr Wert
  const int czahl2{3};                          // 3 ist Literal, also  constexpr
  constexpr long long erg3{fakultaet1(czahl2)};
  std::cout << "Ergebnis = " << erg3 << '\n';
  // 4) constexpr-Funktion liefert constexpr Wert
  constexpr long long erg4{fakultaet1(3)};      // 3 ist Literal, also  constexpr
  std::cout << "Ergebnis = " << erg4 << '\n';
}

