#include <algorithm>
#include <functional>
#include <iostream>
#include <string_view>
using namespace std;

struct Reverse {
  [[nodiscard]] auto operator()(char c1, char c2) const
  {
    if (c1 < c2) return strong_ordering::greater;
    if (c1 > c2) return strong_ordering::less;
    return strong_ordering::equal;
  }
};

int main()
{
  string_view s1("Annabell");
  string_view s2("Francesco");
  auto ergebnis = lexicographical_compare_three_way(s1.begin(), s1.end(), 
                                                    s2.begin(), s2.end()
                                                    //, Reverse()
                                                    );
  string_view op{" == "};                         //  strong_ordering::equal
  if (ergebnis == strong_ordering::less) {
    op = " < ";
  } else if (ergebnis == strong_ordering::greater) {
    op = " > ";
  }
  cout << s1 << op << s2 <<'\n';
}

