#include <algorithm>
#include <iostream>
#include <iterator>
#include <vector>
using namespace std;

void anzeige(const vector<string*>& v)       // Hilfsfunktion
{
  for (auto strPtr : v) {
    cout << *strPtr << "  ";
  }
  cout << '\n';
}

int main()
{
  // Vektor mit Strings
  vector<string> stringvector{"string", "vektor", "mit", "mit",
                              "dubletten", "dubletten", "dubletten"};
  vector<string*> v;                         // Vektor mit Zeigern auf Strings
  for (auto& str : stringvector) {
    v.push_back(&str);                       // Adresse eintragen
  }
  cout << "Original:\n";
  anzeige(v);
  // Ein Container muss für unique() sortiert sein.
  // Die Lambda-Funktion vergleicht die Werte, nicht die Zeiger!
  ranges::sort(v, [](auto p1, auto p2) { return *p1 < *p2; });
  cout << "sortiert:\n";
  anzeige(v);
  // Die Lambda-Funktion vergleicht die Werte, nicht die Zeiger!
  v.erase(ranges::unique(v, [](auto p1, auto p2) { return *p1 == *p2; }
                        ).begin(), v.end());
  cout << "nach unique und erase:\n";
  anzeige(v);
}

