#include <cctype>
#include <fstream>
#include <iostream>
#include <locale>
#include <map>
#include <set>
#include <showContainer.h>
#include <string>
using namespace std;

int main(int argc, char* argv[])
{
  if (argc == 1) {
    cout << "Gebrauch: " << argv[0]
         << " Dateiname [locale]\nBeispiele (vorgegebene Locale: C)\n"
         << argv[0] << " datei de_DE\n" << argv[0] << " datei\n";
    return 0;
  }
  ifstream quelle(argv[1]);
  if (!quelle.good()) {
    cout << argv[1] << " nicht gefunden!\n";
    return 1;
  }

  if (argc == 3) {
    locale::global(locale(argv[2]));          // ggf. global setzen
                // für jeden folgenden Aufruf des locale()-Konstruktors
  }
  
  map<string, set<int>, locale> bezeichnerZeilenMap;
  int zeilennr{1};
  while (quelle.good()) {
    char c{'\0'};
    while (quelle.good()                // Anfang des Bezeichners finden
            && !(isalpha(static_cast<unsigned char>(c)) || '_' == c)) {
      quelle.get(c);
      if (c == '\n') {
        ++zeilennr;
      }
    }
    if (quelle.good()) {
      string bezeichner(1, c);
      while (quelle.good()              // Rest des Bezeichners einsammeln
              && (isalnum(static_cast<unsigned char>(c)) || '_' == c)) {
        quelle.get(c);
        if (isalnum(static_cast<unsigned char>(c)) || '_' == c)
          bezeichner += c;
      }
      quelle.putback(c);                            // zurück an den Eingabestrom
      if (c) {                                      // Bezeichner gefunden?
        bezeichnerZeilenMap[bezeichner].insert(zeilennr);  // Eintrag
      }
    }
  }

  for (const auto& mapEintrag : bezeichnerZeilenMap) {
    cout << mapEintrag.first;                            // Bezeichner
    cout.width(20 - ssize(mapEintrag.first));            // Position bis : einstellen
    cout << ": ";
    showContainer(mapEintrag.second);                    // Zeilennummern
  }
}
