#ifndef SPLIT_H
#define SPLIT_H
#include <string>
#include <string_view>
#include <vector>

[[nodiscard]] inline auto split(std::string_view s, std::string_view trenn)
{
  std::vector<std::string> ergebnis;
  std::string::size_type start {0};  
  std::string::size_type pos {0};
  do {
    pos = s.find_first_of(trenn, start);
    if(pos != std::string::npos) {
      ergebnis.emplace_back(s.substr(start, pos - start));
      start = pos + 1;
    }
  } while (pos != std::string::npos);
  if(start < s.size()) {         // ggf. verbleibenden Rest anhängen
    ergebnis.emplace_back(s.substr(start, s.size()));
  }
  return ergebnis;
}
#endif
