//  Datei-Statistik
#include <cstdlib>          //  exit()
#include <cstring>
#include <fstream>
#include <iostream>
#include <locale>
#include <string>

namespace {
  void zaehlen(const std::string& dateiname, int& zeilenzahl, int& wortzahl, int& zeichenzahl)
{
  std::ifstream quelle(dateiname);
  if (!quelle) {
      throw std::ios::failure("Dateifehler");
  }
  char c {};
  zeichenzahl = wortzahl = zeilenzahl = 0;
  bool wort = false;

  while (quelle.good() && quelle.get(c)) {
    if (c == '\n') {
      ++zeilenzahl;
    }
    else {
      ++zeichenzahl;
    }
    if (isalpha(static_cast<unsigned char>(c))) {  // eingestellte locale wird beruecksichtigt
      wort = true;             // Wortanfang, oder  c ist in einem Wort
    }
    else {
      if (wort) {
        ++wortzahl;          // Wortende ueberschritten
      }
      wort = false;
    }
  }
}
}
using namespace std;

int main(int argc, char* argv[])
{
  if (argc != 2) {
    cerr << "Gebrauch: wcErsatz.exe eingabe.txt\n";
    return 1;
  }
  locale::global(locale("de_DE.utf8"));          //  Umlaute beruecksichtigen

  int zeilenzahl = 0;
  int wortzahl = 0;
  int zeichenzahl = 0;
  try {
    zaehlen(argv[1], zeilenzahl, wortzahl, zeichenzahl);
  }
  catch (...) {
    cerr << "Fehler beim Oeffnen der Datei!\n";
  }
  cout << "Anzahl der Zeichen (ohne Zeilenendekennung) = " << zeichenzahl << '\n';
  cout << "Anzahl der Worte   = " << wortzahl << '\n';
  cout << "Anzahl der Zeilen  = " << zeilenzahl << '\n';
}
