#include <algorithm>
#include <iostream>
#include <numeric>
#include <showContainer.h>
#include <string_view>
#include <vector>
using namespace std;

int main()
{
  vector<char> v(26);
  iota(v.begin(), v.end(), 'a');             // Alphabet mit Kleinbuchstaben erzeugen
  showContainer(v, "\n");
  cout << "remove 't': ";
  auto last = ranges::remove(v, 't').begin();
  // last = neues Ende nach der Verschiebung, v.end() bleibt unverändert!
  showContainer(v.begin(), last);            // Anzeige nur bis last
  // Vokale entfernen:
  last = ranges::remove_if(ranges::subrange(v.begin(), last), 
     [](char c) {  return string_view {"aeiouyAEIOUY"}.find(c) 
                                   != std::string_view::npos;}
                          ).begin();
  cout << "nur noch Konsonanten übrig: ";
  showContainer(v.begin(), last);           // bcdfghjklmnpqrsvwxz
  cout << "\nVollständige Sequenz einschließlich bedeutungsloser "
          "Elemente am Ende:\n";
  showContainer(v, "\n");
}

