#include <algorithm>
#include <showContainer.h>
#include <string_view>
#include <vector>

struct IstZitrusfrucht {
  [[nodiscard]] bool operator()(std::string_view a) const 
  {
    return a == "Zitrone" || a == "Apfelsine" || a == "Limone";
  }
};

using namespace std;

int main()
{
  vector<string_view> obstkorb{"Apfel", "Apfelsine", "Zitrone"};
  showContainer(obstkorb);                   // Apfel Apfelsine Zitrone

  cout << "replace: Apfel durch Quitte ersetzen:\n";
  replace(obstkorb.begin(), obstkorb.end(), string_view("Apfel"), 
          string_view("Quitte"));
  showContainer(obstkorb);                   // Quitte Apfelsine Zitrone

  cout << "replace_if: Zitrusfrüchte durch Pflaumen ersetzen:\n";
  replace_if(obstkorb.begin(), obstkorb.end(), IstZitrusfrucht(),
             string_view("Pflaume"));
  showContainer(obstkorb);                   // Quitte Pflaume Pflaume

  cout << "replace_copy: kopieren und ersetzen der Pflaumen durch Limonen:\n";
  vector<string_view> kiste(obstkorb.size());
  replace_copy(obstkorb.begin(), obstkorb.end(), kiste.begin(),
               string_view("Pflaume"), string_view("Limone"));
  showContainer(kiste);                      // Quitte Limone Limone

  cout << "replace_copy_if: kopieren und ersetzen der Zitrusfrüchte durch "
          "Tomaten:\n";
  replace_copy_if(kiste.begin(), kiste.end(), obstkorb.begin(), IstZitrusfrucht(),
                  string_view("Tomate"));
  showContainer(obstkorb);                   // Quitte Tomate Tomate
}
