#include <functional>
#include <iostream>
using std::bind;
using namespace std::placeholders;           // für \_1, \_2 usw.

template <class T>                           // T muss ein Typ für Funktionsobjekte sein
void aufrufen(T funcObj)
{
  constexpr int i1 = 1;
  constexpr int i2 = 3;
  constexpr int i3 = 5;
  const auto doppel = funcObj(i1, i2, i3);          // Funktionsaufruf über Objekt
  std::cout << doppel << '\n';
}

int verdoppeln(int i) { return 2 * i; }

int main()
{
  aufrufen(bind(verdoppeln, 9));             // Funktion an Wert binden
  aufrufen(bind(verdoppeln, _1));            // Funktion an Parameter 1 binden
  aufrufen(bind(verdoppeln, _2));            // Funktion an Parameter 2 binden
  aufrufen(bind(verdoppeln, _3));            // Funktion an Parameter 3 binden
}

