#include "Name.h"
#include <iostream>
#include <utility>

class Haustier {
public:
  template <class T>
  Haustier(T&& n) 
    : name(std::forward<T>(n)) // Name(Name&&) falls R-Wert
                               // Name(const Name&) falls L-Wert
  { 
    std::cout << "Haustier(T&&)\n";
  }

private:
   Name name;
};

int main()
{
  Name katzenname("Mauz");
  Haustier katze1(katzenname);               // Lvalue
  Haustier katze2(Name("Miezi"));            // Rvalue 
}
