#include <cstddef>
#include <iostream>
#include <tuple>
#include <utility>

// Abbruch der Rekursion bei leerer Folge
template <typename Tuple>
auto berechnesumme(const Tuple&, std::index_sequence<>) // 1. Parameter nicht benutzt
{
  return 0;
}

template <typename Tuple, std::size_t I, std::size_t... Zahlenfolge>
auto berechnesumme(const Tuple& t, std::index_sequence<I, Zahlenfolge...>)
{
  return std::get<I>(t) 
          + berechnesumme(t, std::index_sequence<Zahlenfolge...>());
}

template <typename... T>
auto tupelsumme(const std::tuple<T...>& t)
{
  using indexfolge = std::make_index_sequence<sizeof...(T)>;
  return berechnesumme(t, indexfolge());
}

int main()
{
  auto tupel{std::make_tuple(3.1, 4.2, -17.0)};
  std::cout << tupelsumme(tupel) << '\n';
}
