#ifndef IDISTREAMITERATOR_H
#define IDISTREAMITERATOR_H
#include <cctype>
#include <fstream>

class IdIstreamIterator {
public:
  IdIstreamIterator() = default;

  explicit IdIstreamIterator(std::ifstream& ifstr)
    : is(&ifstr)
  { }

  [[nodiscard]] auto operator*() const { return bezeichner; }

  IdIstreamIterator& operator++() 
  {
    bezeichner = "";
    char c = '\0';
    // Wortanfang finden
    while (is->good() && !(isalpha(static_cast<unsigned char>(c)) || '_' == c)) {
      is->get(c);
    }
    bezeichner += c;
    // Wenn der Anfang gefunden wurde, werden alle folgenden Unterstriche und alphanumeri-
    // schen Zeichen gesammelt. Whitespace oder Sonderzeichen beenden den Leseprozess.
    while (is->good() && (isalnum(static_cast<unsigned char>(c)) || '_' == c)) {
      is->get(c);
      if (isalnum(static_cast<unsigned char>(c)) || '_' == c)
        bezeichner += c;
    }
    if (!is->good()) {
      is = nullptr;
    }
    else {
      // Das letzte Zeichen gehört nicht zum Identifier und wird deshalb zurückgeschrieben.
      is->putback(c);
    }
    return *this; 
  }

  [[nodiscard]] IdIstreamIterator operator++(int) 
  { 
    auto tmp = *this;
    ++*this;
    return tmp;
  }
friend bool operator==(const IdIstreamIterator&, const IdIstreamIterator&);
private:
  std::string bezeichner;
  std::istream* is {nullptr};
};

bool operator==(const IdIstreamIterator& i1, const IdIstreamIterator& i2)
{
  return i1.is == i2.is;
}
#endif
