#include <array>
#include <iostream>
#include <locale>
#include <stdexcept>
using namespace std;

int main()
{
  locale env("");
  cout << "aktuell eingestellte Locale: " << env.name() << '\n';
  constexpr array locales {              // alle Systeme:
                           "C",          // classic C
                           "",           // eingestellte Umgebung
                           // manche Systeme
                           // Deutsch, Deutsch UTF, am. Englisch UTF, Spanisch
                           "de_DE", "de_DE.utf8", "de_DE.iso88591",
                           "en_US.utf8", 
                           "es_ES", "falsch" 
                          };
  cout << "\nTest der locale-Unterstuetzung fuer C++:\n\n";
  for (auto locstring : locales) {
    cout << "locale \"" << locstring << "\" ist diesem C++-Compiler ";
    try {
      locale loc(locstring);
      cout << "bekannt.\n";
    }
    catch (const runtime_error& e) {
      cout << "NICHT bekannt." << e.what() << '\n';
    }
  }
}
