#include <cstdlib>                          //  qsort()
#include <cstring>
#include <iostream>
using namespace std;

// Definition der Vergleichsfunktion:
[[nodiscard]] int icmp(const void* a, const void* b)
{
  // Typumwandlung der Zeiger auf void in Zeiger auf int und anschließende Dereferenzierung
  // (von rechts lesen). Die Typumwandlung meint, dass die Speicherinhalte, auf die a bzw. 
  // b verweisen, als int zu interpretieren sind.
  int ia {*static_cast<const int*>(a)};
  int ib {*static_cast<const int*>(b)};
  // Vergleich und Ergebnisrückgabe ( > 0, = 0 oder < 0)
  if (ia == ib) {
    return 0;
  }
  return ia > ib ? 1 : -1;
}

int main()
{
  int ifeld[]{100, 22, 3, 44, 6, 9, 2, 1, 8, 9};
  constexpr int anzahlElemente{size(ifeld)};
  qsort(ifeld, anzahlElemente, sizeof(ifeld[0]), icmp);  // sortieren
  for (int i : ifeld) {             // Ausgabe
    cout << " " << i;
  }
  cout << '\n';
}

