#ifndef SIMPLESTACK2_H
#define SIMPLESTACK2_H
#include <array>
#include <cassert>

template <typename T, int maxSize>
class SimpleStack2 {
public:
  [[nodiscard]] bool empty() const { return anzahl == 0; }
  [[nodiscard]] bool full() const { return anzahl == maxSize; }
  [[nodiscard]] int size() const { return anzahl; }
  void clear() { anzahl = 0; }          // Stack leeren

  const T& top() const;                 // letztes Element sehen
  void pop();                           // Element entnehmen
  // Vorbedingung für top und pop: Stack ist nicht leer

  void push(const T& x);                // x auf den Stack legen
  // Vorbedingung für push: Stack ist nicht voll

private:
  int anzahl{0};                        // Anfangswert
  std::array<T, maxSize> arr{};         // Behälter für Elemente

};

// noch fehlende Implementierungen
template <typename T, int m>          // Parameter m wird nur für den Typ benutzt
const T& SimpleStack2<T, m>::top() const
{
  assert(!empty());
  return arr.at(anzahl - 1);
}

template <typename T, int m>          // Parameter m wird nur für den Typ benutzt
void SimpleStack2<T, m>::pop()
{
  assert(!empty());
  --anzahl;
}

template <typename T, int m>          // Parameter m wird nur für den Typ benutzt
void SimpleStack2<T, m>::push(const T& x)
{
  assert(!full());
  arr.at(anzahl++) = x;
}
#endif

