#ifndef STACKDIFFERENTCONTAINER1_H
#define STACKDIFFERENTCONTAINER1_H
#include <cassert>
#include <vector>

template <typename T, typename Container = std::vector<T> >
class StackDifferentContainer1 {
public:
  [[nodiscard]] bool empty() const { return arr.size() == 0; }
  [[nodiscard]] auto size() const { return arr.size(); }
  void clear() { arr.clear(); } // Stack leeren
  
  // Vorbedingung für top und pop: Stack ist nicht leer
  const T &top() const // letztes Element sehen
  {
    assert(!empty());
    return arr.back();
  }
  
  void pop() // Element entfernen
  {
    assert(!empty());
    arr.pop_back();
  }
  
  void push(const T &x) // x auf den Stack legen
  {
    arr.push_back(x);
  }

private:
  Container arr; // Behälter für Elemente
};
#endif
