#ifndef STRECKE_H
#define STRECKE_H
#include "GraphObj.h"

class Strecke : public GraphObj {           // erben von GraphObj
public:
  Strecke(Ort ort1, Ort ort2)               // Initialisierung mit Initialisierungsliste:
      : GraphObj{ort1},                     // Initialisierung des Subobjekts
        endpunkt{ort2}                      // Initialisierung des Attributs
  { }                                       // leerer Code-Block

  [[nodiscard]] auto laenge() const 
  { 
    return entfernung(bezugspunkt(), endpunkt); 
  }
  // Definition der rein virtuellen Methoden:
  [[nodiscard]] double flaeche() const override   //  siehe Text unten
  {   
    return 0.0;
  }

  void zeichnen() const override
  {
    GraphObj::zeichnen();
    std::cout << "Strecke von ";
    anzeigen(bezugspunkt());
    std::cout << " bis ";
    anzeigen(endpunkt);
    std::cout << '\n';
  }
private:
  Ort endpunkt;    // 2. Punkt der Strecke (der 1. ist GraphObj::Referenzkoordinaten)
};
#endif

