#ifndef GRAPHOBJ_H
#define GRAPHOBJ_H
#include <Ort.h>                            // in cppbuch/include

class GraphObj {                            // Version 1
public:
  explicit GraphObj(Ort einOrt)             // allgemeiner Konstruktor
      : referenzkoordinaten{einOrt}
  { }

  // Bezugspunkt ermitteln
  [[nodiscard]] auto bezugspunkt() const { return referenzkoordinaten; }

  // alten Bezugspunkt ermitteln und gleichzeitig neuen wählen
  auto bezugspunkt(Ort neuerOrt)
  {
    Ort temp{referenzkoordinaten};
    referenzkoordinaten = neuerOrt;
    return temp;
  }

  // Koordinatenabfrage
  [[nodiscard]] auto getX() const { return referenzkoordinaten.getX(); }
  [[nodiscard]] auto getY() const { return referenzkoordinaten.getY(); }

  // Standardimplementation (wird von abgeleiteten Klassen redefiniert)
  [[nodiscard]] auto flaeche() const { return 0.0; }
private:
  Ort referenzkoordinaten;
};

// Die Entfernung zwischen 2 GraphObj-Objekten ist hier als Entfernung ihrer
//  Bezugspunkte (überladene Funktion) definiert.
[[nodiscard]] inline auto entfernung(const GraphObj& g1, const GraphObj& g2)
{
  return entfernung(g1.bezugspunkt(), g2.bezugspunkt());
}
#endif

