#ifndef BESCHRIFTETESRECHTECK_H
#define BESCHRIFTETESRECHTECK_H
#include "BeschriftetesObjekt.h"
#include "Rechteck.h"

// Mehrfachvererbung
class BeschriftetesRechteck : public BeschriftetesObjekt, public Rechteck {
public:
  BeschriftetesRechteck(Ort ort, int h, int b, const std::string& beschr)
      : GraphObj(ort), BeschriftetesObjekt(ort, beschr), Rechteck(ort, h, b)
  {
  }

  // Definition der rein virtuellen Methoden
  [[nodiscard]] double flaeche() const override
  {
    // Definition ist notwendig, damit die Klasse nicht abstrakt ist
    // (durch Vererbung über BeschriftetesObjekt und GraphObj)
    return Rechteck::flaeche();
  }

  void zeichnen() const override
  {
    Rechteck::zeichnen();
    BeschriftetesObjekt::zeichnen();
  }
};
#endif          // BESCHRIFTETESRECHTECK_H

