#include <iostream>
#include <memory>

#define PRINT(X) std::cout << (#X) << " = " << (X) << '\n'

class Basis {
  double bWert;

public:
  Basis(double b = 0.0) : bWert(b) {}
  virtual          // virtueller Destruktor!
      ~Basis()
  {
    std::cout << "Objekt " << bWert << " Basis-Destruktor aufgerufen!\n";
  }
  Basis(const Basis&) = delete;                     // Regel der großen Drei, siehe
                                                    // Seite 319
  Basis& operator=(const Basis&) = delete;          // dito
};

class Abgeleitet : public Basis {
  double aWert;

public:
  Abgeleitet(double b = 0.0, double a = 0.0) : Basis(b), aWert(a) {}

  ~Abgeleitet() override
  {
    std::cout << "Objekt " << aWert << " Abgeleitet-Destruktor aufgerufen!\n";
  }
  Abgeleitet(const Abgeleitet&) = delete;          // Regel der großen Drei, siehe Seite
                                                    // 319
  Abgeleitet& operator=(const Abgeleitet&) = delete;          // dito
};

int main()
{
  std::unique_ptr<Basis> pb = std::make_unique<Basis>(1.0);
  PRINT(sizeof(*pb));

  std::unique_ptr<Abgeleitet> pa = std::make_unique<Abgeleitet>(2.0, 2.2);
  PRINT(sizeof(*pa));

  std::unique_ptr<Basis> pba = std::make_unique<Abgeleitet>(3.0, 3.3);
  PRINT(sizeof(*pba));
}

