#ifndef C_H
#define C_H
#include "B.h"

class C : public B {
public:
  C(int a_, int b_, int c_)
      : B(a_, b_), // Oberklassen-Subobjekt
        c{c_}      // klassenlokale Daten
  {
  }
  C& operator=(const C&) = delete;

  [[nodiscard]] std::unique_ptr<A> clone() const override
  {
    std::cout << "virtual C* C::clone()\n";
    return std::unique_ptr<A>(new C(*this));
  }

  void ausgabe() const override
  {
    B::ausgabe();
    std::cout << "C.c = " << c << ' ';
  }

  [[nodiscard]] bool isEqual(const A& arg) const override
  {
    std::cout << "C::isEqual(const A& arg)\n";
    return B::isEqual(arg) && c == dynamic_cast<const C&>(arg).c;
  }

protected:
  C(const C&) = default;

private:
  int c;
};
#endif
