#ifndef SINUS_H
#define SINUS_H
#include <cmath>                            // sin()
#include <numbers>                          // siehe Seite 196

class Sinus {
public:
  enum class Modus { bogenmass, grad };
  explicit constexpr Sinus(Modus m = Modus::bogenmass) 
  : berechnungsart{m} 
  {}

  [[nodiscard]] double operator()(double arg) const
  {
    double erg = NAN;             // not a number
    switch (berechnungsart) {
    case Modus::bogenmass:
      erg = std::sin(arg);
      break;
    case Modus::grad:
      erg = std::sin(arg / 180.0 * std::numbers::pi);
      break;
    }
    return erg;
  }
private:
  Modus berechnungsart;
};
#endif

