#ifndef OBJEKT_H_
#define OBJEKT_H_
#include <cstddef>
#include <iostream>

class Objekt {
public:
  virtual ~Objekt() 
  { 
    std::cout << "Objekt-Destruktor aufgerufen (" << this << ")\n"; 
  }
  Objekt() = default;
  Objekt(const Objekt&) = delete;
  Objekt& operator=(const Objekt&) = delete;

  [[nodiscard]] static void* operator new(std::size_t size)
  {
    std::cout << "new aufgerufen. size=" << size << '\n';
    return ::operator new(size);
  }
  static void operator delete(void* ptr, std::size_t size)
  {
    std::cout << "delete aufgerufen. size=" << size << '\n';
    ::operator delete(ptr);
  }
  [[nodiscard]] static void* operator new[](std::size_t size)
  {
    std::cout << "new[] aufgerufen. size=" << size << '\n';
    return ::operator new[](size);
  }
  static void operator delete[](void* ptr, std::size_t size)
  {
    std::cout << "delete[] aufgerufen. size=" << size << '\n';
    ::operator delete[](ptr);
  }
};
#endif
