#ifndef C_H
#define C_H
#include "B.h"

class C : public B {
public:
  C(int a_, int b_, int c_)
      : B(a_, b_), // Oberklassen-Subobjekt
        c{c_}
  { // lokale Daten
  }
  C(const C&) = default;

  [[nodiscard]] C& assign(const A& rhs) override
  {
    std::cout << "virtual C& C::assign=(const A&)\n";
    if (typeid(*this) != typeid(rhs)) {
      throw std::bad_typeid();
    }
    C temp(static_cast<const C&>(rhs));
    swap(temp);
    return *this;
  }

  C& operator=(const C& rhs)
  {
    std::cout << "C& operator=(const C& rhs)\n";
    return assign(rhs);
  }

  void ausgabe() const override
  {
    B::ausgabe();
    std::cout << "C.c = " << c << ' ';
  }

  void swap(C& rhs)
  {
    B::swap(rhs);        // Oberklassendaten
    std::swap(c, rhs.c); // lokale Daten
  }

  [[nodiscard]] bool isEqual(const A& arg) const override
  {
    std::cout << "C::isEqual(const A& arg)\n";
    return B::isEqual(arg) && c == static_cast<const C&>(arg).c;
  }

private:
  int c;
};
#endif // C_H
