#include "datumeingabeoperator.h"

// Einleseoperator für ein Datum. Erlaubte Formate: Tag.Monat.Jahr oder
// Tag/Monat/Jahr
std::istream& operator>>(std::istream& eingabe, Datum& d)
{
  char c{'\0'};
  int tag{0};
  int monat{0};
  int jahr{0};
  eingabe >> tag >> c; // Tag und 1. Trennzeichen
  if (c != '.' && c != '/') {
    eingabe.setstate(std::ios::failbit); // Status setzen
  }
  else {
    eingabe >> monat >> c; // Monat und 2. Trennzeichen
    if (c != '.' && c != '/') {
      eingabe.setstate(std::ios::failbit); // Status setzen
    }
    else {
      eingabe >> jahr;
      try {
        Datum temp(tag, monat, jahr);
        d = temp;
      }
      catch (const UngueltigesDatumException& err) {
        eingabe.setstate(std::ios::failbit);
      }
    }
  }
  if (!eingabe.good()) {
    throw UngueltigesDatumException(" ungueltige Eingabe!");
  }
  return eingabe;
}
