#include <format>
#include <iostream>
using namespace std;

int main()
{
  cout << format("{:-<40}\n", "linksbuendig mit Strichen");
  cout << format("{:.>40}\n", "rechtsbuendig mit Punkten");
  cout << format("{:*^40}\n", "zentriert mit Sternchen");
  // ganze Zahlen
  cout << format("{:0>10}\n", 12345);        // ggf. führende Nullen, Weite = 10
  cout << format("{: >10}\n", -12345);       // Leerzeichen statt Nullen
  // weitere Ganzzahl-Formate (0 ist die Nr. des Arguments):
  cout << format("binär {0:b}, oktal {0:o}, dezimal {0:d}, hex {0:x}\n"
                 "dezimal {1:d} = hex {1:X}\n", 1024, 255); 
  // mit Weite 15 und Kennung # :  0b 0x usw.
  cout << format("binär   {0:#15b}\noktal   {0:#15o}\ndezimal {0:#15d}\n"
                 "hex     {0:#15x}\n", 255);
  // Gleitkomma-Zahlen (auch F statt f)
  cout << format("{:+f}\n", 12345.6);        // immer mit +-Zeichen und
                                             // 6 Nachkommastellen (Vorgabe)
  cout << format("{: f}\n{: f}\n", 12345.6, -12345.6); // Leerzeichen statt +-Zeichen
  cout << format("{:f}\n", -12345.6);        // nur - Zeichen, kein +
  cout << format("{: 15.3f}\n", -12345.6);   // Weite=15, 3 Nachkommastellen
  cout << format("{:015.3f}\n", -12345.6);   // dito, aber führende Nullen
  cout << format("{:15.3e}\n", -12345.6);    // Wissenschaftliche Notation
  cout << format("{:e}\n", -12345.6);        // dito, 6 Nachkommastellen (Vorgabe)
  cout << format("{:E}\n", -12345.6);        // dito, großes E
  cout << format("{:g}\n", -12345.6);      // mit Komma oder Exponent, je nach Größe
  cout << format("{:g}\n", -123456789123.4); // dito
  // geschweifte Klammern mit {{}}
  cout << format("{{{}}}\n", 10);            // { als Escape-Zeichen
  // Die Option L berücksichtigt die Sprachumgebung. 
  locale::global(locale("de_DE.utf8"));           // deutsche Sprachumgebung setzen
  cout << format("{:15.8L}\n",               // Dezimalkomma statt -punkt
                 -12345.678);                // 15.8 : Weite 15, 8 Ziffern
}


