//  Datei hexadezimal ausgeben
// Hilfsmittel: Bitoperationen
#include <cstdlib>          // für exit()
#include <fstream>
#include <iostream>
#include <string>
using namespace std;

int main()
{
  cout << "Dateiname :";
  string quelldateiname{"unbekannt"};
  getline(cin, quelldateiname);

  ifstream quelle(quelldateiname, ios::binary);
  if (!quelle) {          // muss existieren
    cerr << quelldateiname << " kann nicht geöffnet werden!\n";
    exit(-1);
  }

  // char ist notwendig, weil get(unsigned char&) nicht
  // implementiert ist (GNU C++)
  char c{'x'};          // signed!
  int count{0};
  while (quelle.get(c)) {
    auto uc = static_cast<unsigned char>(c);          // unsigned!
    auto low = static_cast<unsigned int>(uc) & 15;
    auto hi = static_cast<unsigned int>(uc) >> 4;
    // Umsetzung der Werte 0..15 auf ASCII-Zeichen:
    if (low < 10) {
      low += 48;          // '0'...'9'
    }
    else {
      low += 55;          // 'A'...'F'
    }
    if (hi < 10) {
      hi += 48;
    }
    else {
      hi += 55;
    }
    cout << static_cast<char>(hi) << static_cast<char>(low) << ' ';
    if (++count % 20 == 0) {
      cout << '\n';
    }
  }
  cout << '\n';
}
