#ifndef HEAP_H
#define HEAP_H
#include <algorithm>
#include <functional>
#include <vector>

#define TESTHEAP
// siehe unten
template <class T, class Compare = std::less<T>> class Heap {
public:
  Heap(const Compare& cmp = Compare()) 
  : comp(cmp), v(std::vector<T>(1)), last(v.begin())
  {}
  void push(const T& t)
  {
    if (anz == v.size()) {
      v.resize(anz + 100);
      last = v.begin() + anz;          // neu bestimmen
    }
    *last = t;
    push_heap(v.begin(), ++last, comp);
    ++anz;
#ifdef TESTHEAP
    if (!is_heap(v.begin(), last)) {
      throw "push(): Heap-Bedingung verletzt!";
    }
#endif
  }
  void pop()
  {
    pop_heap(v.begin(), last--, comp);
    --anz;
#ifdef TESTHEAP
    if (!is_heap(v.begin(), last)) {
      throw "pop(): Heap-Bedingung verletzt!";
    }
#endif
  }
  [[nodiscard]] const T& top() const { return *v.begin(); }
  [[nodiscard]] bool empty() const { return anz == 0; }
  [[nodiscard]] auto size() const { return anz; }
  [[nodiscard]] std::vector<T> toSortedVector() const
  {
    std::vector<T> temp(v.begin(), v.begin() + anz);
    sort_heap(temp.begin(), temp.end(), comp);
    return temp;
  }

private:
  unsigned int anz {0};
  Compare comp;
  std::vector<T> v;
  typename std::vector<T>::iterator last;
};
#endif
