#ifndef PERSON_H
#define PERSON_H
#include <string>
#include <utility>

class Person {
public:
  Person(std::string n, std::string v) 
  : nachname{std::move(n)}, vorname{std::move(v)} {}
  virtual ~Person() = default;
  Person(const Person&) = default;
  Person& operator=(const Person&) = default;
  Person(Person&&) = default;
  Person& operator=(Person&&) = default;
  const auto& getNachname() const { return nachname; }
  const auto& getVorname() const { return vorname; }
  virtual std::string toString() const = 0;

private:
  std::string nachname;
  std::string vorname;
};

// Die Standardimplementierung einer rein virtuellen Methode
// muss außerhalb der Klassendefinition stehen:
inline std::string Person::toString() const { return vorname + " " + nachname; }
#endif
