#include <iostream>

template <typename Feldtyp>
void tabellenausgabe2D(Feldtyp tabelle, int n)
{
  const int spalten = sizeof tabelle[0] / sizeof tabelle[0][0];
  for (int i = 0; i < n; ++i) {
    for (int j = 0; j < spalten; ++j)
      std::cout << tabelle[i][j] << ' ';
    std::cout << '\n';
  }
  std::cout << '\n';
}

int main()
{
  /* Es muss m = p, r = n und s = q gelten, damit die
  Matrizenmultiplikation definiert ist. Daher benötigt man nur
  noch drei Konstanten.
  */
  // Initialisierung (Beispiel)
  constexpr int n{2};
  constexpr int m{3};
  constexpr int q{4};
  int a[n][m] = {{1, 2, 3}, {4, 5, 6}};
  int b[m][q] = {{1, 2, 3, 0}, {4, 1, 1, 5}, {1, 7, 1, 4}};
  int c[n][q];

  // Multiplikation
  for (int i = 0; i < n; ++i) {
    for (int j = 0; j < q; ++j) {
      c[i][j] = 0;
      for (int k = 0; k < m; ++k)
        c[i][j] += a[i][k] * b[k][j];
    }
  }
  // Ergebnis ausgeben oder weiterrechnen
  tabellenausgabe2D(a, n);
  std::cout << "multipliziert mit\n";
  tabellenausgabe2D(b, m);
  std::cout << "ergibt\n";
  tabellenausgabe2D(c, n);
  // ...
}
