#ifndef PERSON_H
#define PERSON_H
#include <string>

class Person {
public:
  Person(const std::string& n, const std::string& v) : nachname{n}, vorname{v} {}
  virtual ~Person() = default;
  Person(const Person&) = default;
  Person& operator=(const Person&) = default;
  [[nodiscard]] auto getNachname() const { return nachname; }
  [[nodiscard]] auto getVorname() const { return vorname; }
  [[nodiscard]] virtual std::string toString() const = 0;

private:
  std::string nachname;
  std::string vorname;
};

// Die Standardimplementierung einer rein virtuellen Methode
// muss außerhalb der Klassendefinition stehen:
inline std::string Person::toString() const { return vorname + " " + nachname; }
#endif
