#include "../2/ProfessorIn.h"
#include "../2/StudentIn.h"
#include <iostream>
#include <memory>
#include <vector>
using namespace std;

int main()
{
  vector<shared_ptr<Person>> diePersonen;
  diePersonen.push_back(make_shared<StudentIn>("Herder", "Johann Gottfried", "635374"));
  diePersonen.push_back(make_shared<ProfessorIn>("Kant", "Immanuel", "Philosophie"));
  diePersonen.push_back(make_shared<StudentIn>("von Schön", "Theodor", "123429"));

  cout << "Vornamen:\n";
  for (auto personPtr : diePersonen) {
    cout << personPtr->getVorname() << '\n';
  }

  cout << "toString() ergibt:\n";
  for (auto personPtr : diePersonen) {
    cout << personPtr->toString() << '\n';
  }

  /* Da im obigen Programm shared_ptr-Zeiger auf Person verwendet werden,
  erfordert ein Zugriff auf Methoden, die nicht in Person
  deklariert sind, eine Typumwandlung. Beispiel: */

  cout << "Die Matrikelnummer von " << diePersonen[0]->getNachname() << " ist "
       << static_cast<StudentIn*>(diePersonen[0].get())   // s.u.
              ->getMatrikelnummer()          // get() gibt den 'rohen Zeiger'
                                             // vom Typ Person* zurück
       << '\n';
  /* Die Typumwandlung in den Typ StudentIn*
  funktioniert natürlich nur, wenn man genau weiß, dass der
  Zeiger an der Stelle 0 auf ein Objekt des dynamischen Typs
  StudentIn verweist. Was, wenn nicht? Das ist Thema der 
  Aufgaben 6.4 und 6.5.
  */
  // kein delete erforderlich
}
